## mingw-w64-glaze-7.1.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

include(cmake/prelude.cmake)

project(
    glaze
    VERSION 7.1.0
    LANGUAGES CXX
)

include(cmake/project-is-top-level.cmake)
include(cmake/variables.cmake)

if (PROJECT_IS_TOP_LEVEL)
  set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
endif()

add_library(glaze_glaze INTERFACE)
add_library(glaze::glaze ALIAS glaze_glaze)


if (MSVC)
  string(REGEX MATCH "\/cl(.exe)?$" matched_cl ${CMAKE_CXX_COMPILER})
  if (matched_cl)
    # for a C++ standards compliant preprocessor, not needed for clang-cl
    target_compile_options(glaze_glaze INTERFACE "/Zc:preprocessor" /permissive- /Zc:lambda)
    
    if(PROJECT_IS_TOP_LEVEL)
      target_compile_options(glaze_glaze INTERFACE 
        $<$<CONFIG:Release>:/GL>
        $<$<CONFIG:MinSizeRel>:/GL>)
      target_link_options(glaze_glaze INTERFACE 
        $<$<CONFIG:Release>:/LTCG /INCREMENTAL:NO>
        $<$<CONFIG:MinSizeRel>:/LTCG /INCREMENTAL:NO>)
    endif()
   endif()
else()
  # Only apply -Wno-missing-braces for C and C++ compilation to avoid breaking ISPC and other language builds
  target_compile_options(${PROJECT_NAME}_${PROJECT_NAME} INTERFACE
    $<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:-Wno-missing-braces>)
endif()

set_property(TARGET ${PROJECT_NAME}_${PROJECT_NAME} PROPERTY EXPORT_NAME glaze)

target_compile_features(${PROJECT_NAME}_${PROJECT_NAME} INTERFACE cxx_std_23)
target_include_directories(
    ${PROJECT_NAME}_${PROJECT_NAME} ${warning_guard}
    INTERFACE "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
)

if(NOT CMAKE_SKIP_INSTALL_RULES)
  include(cmake/install-rules.cmake)
endif()

if (glaze_DEVELOPER_MODE)
  include(cmake/dev-mode.cmake)
endif()

option(glaze_DISABLE_SIMD_WHEN_SUPPORTED
       "disable SIMD optimizations even when targets support it (e.g. AVX2)" OFF)
if(glaze_DISABLE_SIMD_WHEN_SUPPORTED)
  target_compile_definitions(glaze_glaze INTERFACE GLZ_DISABLE_SIMD)
endif()

option(glaze_DISABLE_ALWAYS_INLINE
       "disable forced inlining to reduce binary size and compilation time" OFF)
if(glaze_DISABLE_ALWAYS_INLINE)
  target_compile_definitions(glaze_glaze INTERFACE GLZ_DISABLE_ALWAYS_INLINE)
endif()

option(glaze_BUILD_EXAMPLES "Build GLAZE examples" OFF)

if(glaze_BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

option(glaze_EETF_FORMAT "Enable Erlang external term format parsing" OFF)

if(glaze_EETF_FORMAT)
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
  find_package(Erlang REQUIRED)
  target_link_libraries(
    glaze_glaze ${warning_guard}
    INTERFACE
      Erlang::EI
      Erlang::Erlang
  )
  target_compile_definitions(glaze_glaze INTERFACE GLZ_ENABLE_EETF)
endif(glaze_EETF_FORMAT)

option(glaze_ENABLE_SSL "Enable SSL/TLS support for HTTPS servers" OFF)

if(glaze_ENABLE_SSL)
  find_package(OpenSSL REQUIRED)
  target_link_libraries(
    glaze_glaze ${warning_guard}
    INTERFACE
      OpenSSL::SSL
      OpenSSL::Crypto
  )
  target_compile_definitions(glaze_glaze INTERFACE GLZ_ENABLE_SSL)
endif(glaze_ENABLE_SSL)

=== benchmarks/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(glaze_benchmarks)

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(FetchContent)

# Fetch bencher
FetchContent_Declare(
  bencher
  GIT_REPOSITORY https://github.com/stephenberry/bencher.git
  GIT_TAG main
  GIT_SHALLOW TRUE
)
FetchContent_MakeAvailable(bencher)

# Glaze - use parent directory as header-only library
add_library(glaze INTERFACE)
target_include_directories(glaze INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/../include)

# Lazy JSON benchmark
add_executable(lazy_benchmark lazy_benchmark.cpp)
target_link_libraries(lazy_benchmark PRIVATE
  glaze
  bencher::bencher
)
target_compile_options(lazy_benchmark PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

# Simple float benchmark
add_executable(simple_float_benchmark simple_float_benchmark.cpp)
target_link_libraries(simple_float_benchmark PRIVATE
  glaze
  bencher::bencher
)
target_compile_options(simple_float_benchmark PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

# skip_ws optimization benchmark (PR #2269)
add_executable(skip_ws_benchmark skip_ws_benchmark.cpp)
target_link_libraries(skip_ws_benchmark PRIVATE
  glaze
  bencher::bencher
)
target_compile_options(skip_ws_benchmark PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

# String write optimization benchmark (SWAR-only vs SIMD+SWAR)
# The no-SIMD baseline is a shared library so the linker can't deduplicate
# its glz::write template instantiation with the SIMD-enabled one.
add_library(string_write_no_simd SHARED string_write_no_simd.cpp)
target_link_libraries(string_write_no_simd PRIVATE glaze)
target_compile_definitions(string_write_no_simd PRIVATE GLZ_DISABLE_SIMD)
target_compile_options(string_write_no_simd PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

add_executable(string_write_benchmark string_write_benchmark.cpp)
target_link_libraries(string_write_benchmark PRIVATE
  glaze
  bencher::bencher
  string_write_no_simd
)
target_compile_options(string_write_benchmark PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

# Binary search benchmark (std::lower_bound vs branchless)
add_executable(binary_search_benchmark binary_search_benchmark.cpp)
target_link_libraries(binary_search_benchmark PRIVATE
  glaze
  bencher::bencher
)
target_compile_options(binary_search_benchmark PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

# Ordered map benchmark (glz::ordered_small_map vs glz::ordered_map)
add_executable(ordered_map_benchmark ordered_map_benchmark.cpp)
target_link_libraries(ordered_map_benchmark PRIVATE
  glaze
  bencher::bencher
)
target_compile_options(ordered_map_benchmark PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

# Generic JSON map type benchmark (ordered_small_map vs std::map)
add_executable(generic_benchmark generic_benchmark.cpp)
target_link_libraries(generic_benchmark PRIVATE
  glaze
  bencher::bencher
)
target_compile_options(generic_benchmark PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

# Ordered map memory comparison
add_executable(ordered_map_memory ordered_map_memory.cpp)
target_link_libraries(ordered_map_memory PRIVATE
  glaze
)
target_compile_options(ordered_map_memory PRIVATE
  $<$<CXX_COMPILER_ID:GNU,Clang,AppleClang>:-O3 -march=native>
  $<$<CXX_COMPILER_ID:MSVC>:/O2>
)

=== tests/CMakeLists.txt ===
include(FetchContent)

FetchContent_Declare(
  ut
  GIT_REPOSITORY https://github.com/openalgz/ut
  GIT_TAG v1.1.0
  GIT_SHALLOW TRUE
)

message(STATUS "Fetching dependencies...")
set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL TRUE)
set(CMAKE_SKIP_INSTALL_RULES ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(ut)
set(CMAKE_SKIP_INSTALL_RULES OFF CACHE BOOL "" FORCE)
set_directory_properties(PROPERTIES EXCLUDE_FROM_ALL FALSE)
message(STATUS "...finished fetching dependencies.")

# Setup ASIO dependency (used by networking tests)
# This must be defined here before glz_test_common/glz_test_exceptions
#
# Search order:
#   1. Boost.Asio (via find_package(Boost))
#   2. Standalone Asio (via find_package(Asio) using our FindAsio.cmake)
#   3. FetchContent (if glaze_USE_BUNDLED_ASIO is ON)
#
# Distro maintainers can set -Dglaze_USE_BUNDLED_ASIO=OFF to require system packages.

option(glaze_USE_BUNDLED_ASIO
    "Download ASIO via FetchContent if not found on system (disable for distro builds)"
    ON
)

# First, try Boost.Asio
find_package(Boost QUIET CONFIG)

if(Boost_FOUND)
    message(STATUS "Using Boost.Asio")
    add_library(glz_asio INTERFACE)
    # Boost.Asio is header-only, just need Boost headers
    # Boost::system was removed in Boost 1.89 (it was header-only since 1.69)
    if(TARGET Boost::headers)
        target_link_libraries(glz_asio INTERFACE Boost::headers)
    elseif(TARGET Boost::boost)
        target_link_libraries(glz_asio INTERFACE Boost::boost)
    endif()
else()
    # Second, try standalone Asio
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")
    find_package(Asio QUIET)

    if(Asio_FOUND)
        message(STATUS "Using standalone Asio ${Asio_VERSION}")
        add_library(glz_asio INTERFACE)
        target_link_libraries(glz_asio INTERFACE Asio::Asio)
    elseif(glaze_USE_BUNDLED_ASIO)
        # Third, fetch via FetchContent
        message(STATUS "Fetching standalone Asio via FetchContent")
        FetchContent_Declare(
            asio
            GIT_REPOSITORY https://github.com/chriskohlhoff/asio.git
            GIT_TAG asio-1-36-0
            GIT_SHALLOW TRUE
        )
        FetchContent_MakeAvailable(asio)
        add_library(glz_asio INTERFACE)
        target_include_directories(glz_asio INTERFACE ${asio_SOURCE_DIR}/asio/include)
    else()
        message(FATAL_ERROR
            "ASIO not found and bundling is disabled (glaze_USE_BUNDLED_ASIO=OFF).\n"
            "Options:\n"
            "  - Install Boost with the 'system' component\n"
            "  - Install standalone Asio (headers in standard location)\n"
            "  - Set Asio_INCLUDE_DIR to your Asio headers location\n"
            "  - Set glaze_USE_BUNDLED_ASIO=ON to download via FetchContent"
        )
    endif()
endif()

include(../cmake/code-coverage.cmake)
add_code_coverage_all_targets()

add_library(glz_test_common INTERFACE)
target_compile_features(glz_test_common INTERFACE cxx_std_23)
target_link_libraries(glz_test_common INTERFACE ut::ut glaze::glaze glz_asio)
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    target_compile_options(glz_test_common INTERFACE -fno-exceptions -fno-rtti)
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 13)
            target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic)
        else()
            target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic $<$<CONFIG:Debug>:-Werror>)
        endif()
    elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic $<$<CONFIG:Debug>:-Werror>)
    else()
        target_compile_options(glz_test_common INTERFACE -Wall -Wextra -pedantic)
    endif()

        if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      target_compile_options(glz_test_common INTERFACE -ftime-trace -fsanitize=address -fsanitize-address-use-after-scope -fsanitize=undefined)
      target_link_options(glz_test_common INTERFACE -ftime-trace -fsanitize=address -fsanitize-address-use-after-scope -fsanitize=undefined)
    endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(glz_test_common INTERFACE /GR- /bigobj) #/fsanitize=address
    target_compile_options(glz_test_common INTERFACE /W4 /wd4459 /wd4805)
endif()

add_library(glz_test_exceptions INTERFACE)
target_compile_features(glz_test_exceptions INTERFACE cxx_std_23)
target_link_libraries(glz_test_exceptions INTERFACE ut::ut glaze::glaze glz_asio)
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang")
    target_compile_options(glz_test_exceptions INTERFACE)
    target_compile_options(glz_test_exceptions INTERFACE -Wall -Wextra -pedantic)
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    target_compile_options(glz_test_exceptions INTERFACE /GR- /bigobj) #/fsanitize=address
    target_compile_options(glz_test_exceptions INTERFACE /W4 /wd4459 /wd4805)
endif()

add_subdirectory(api_test)
add_subdirectory(beve_test)
add_subdirectory(cbor_test)
add_subdirectory(buffer_pool_test)
add_subdirectory(cli_menu_test)
add_subdirectory(compare_test)
add_subdirectory(ordered_small_map_test)
add_subdirectory(ordered_map_test)
add_subdirectory(csv_test)
add_subdirectory(eigen_test)
add_subdirectory(example_json)
add_subdirectory(exceptions_test)
add_subdirectory(inplace_vector)
option(glaze_BUILD_PERFORMANCE_TESTS "Build performance tests" ON)
if(glaze_BUILD_PERFORMANCE_TESTS)
    add_subdirectory(int_parsing)
endif()
add_subdirectory(jmespath)
add_subdirectory(jsonrpc_test)
add_subdirectory(key_transformers_test)
add_subdirectory(lib_test)
add_subdirectory(mock_json_test)
add_subdirectory(reflection)
add_subdirectory(roundtrip)
add_subdirectory(stencil)
add_subdirectory(threading_test)
add_subdirectory(toml_test)
add_subdirectory(utility_formats)
add_subdirectory(yaml_test)

add_subdirectory(yaml_conformance)
add_subdirectory(msgpack_test)
add_subdirectory(ostream_buffer_test)
add_subdirectory(istream_buffer_test)

# simple_float_test runs exhaustive tests over all 2^32 float values
# Disabled by default - run via dedicated CI workflow in Release mode
option(glaze_SIMPLE_FLOAT_TEST "Build simple_float exhaustive tests (slow, Release mode recommended)" OFF)
if(glaze_SIMPLE_FLOAT_TEST)
    add_subdirectory(simple_float_test)
endif()

# JSON Tests
add_subdirectory(chrono_test)
add_subdirectory(json_conformance)
if(glaze_BUILD_PERFORMANCE_TESTS)
    add_subdirectory(json_performance)
endif()
add_subdirectory(json_reflection_test)
add_subdirectory(json_test)

option(glaze_BUILD_NETWORKING_TESTS "Build networking tests (requires OpenSSL)" ON)
if(glaze_BUILD_NETWORKING_TESTS)
    add_subdirectory(networking_tests)
endif()

if(glaze_EETF_FORMAT)
    add_subdirectory(eetf_test)
endif(glaze_EETF_FORMAT)

# We don't run find_package_test or glaze-install_test with MSVC/Windows, because the Github action runner often chokes
# Don't run find_package on Clang, because Linux runs with Clang try to use GCC standard library and have errors before Clang 18
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    add_test(
    NAME glaze-install_test
    COMMAND
    "${CMAKE_COMMAND}"
    --install "${PROJECT_BINARY_DIR}"
    --prefix "${CMAKE_CURRENT_BINARY_DIR}/install"
    --config $<CONFIG>
    --verbose
    )

    add_test(
    NAME find_package_test
    COMMAND
    "${CMAKE_CTEST_COMMAND}"
    --verbose
    --output-on-failure
    --build-noclean
    --build-project "${PROJECT_NAME}" # helps msvc when --build-target
    --build-generator "${CMAKE_GENERATOR}"
    --build-config $<CONFIG>
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/find_package"
    "${CMAKE_CURRENT_BINARY_DIR}/find_package"
    --build-options
    "-Dglaze_ROOT:PATH=${CMAKE_CURRENT_BINARY_DIR}/install"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}"
    "-DBUILD_TESTING=ON"
    "$<$<BOOL:${glaze_EETF_FORMAT}>:-Dglaze_EETF_FORMAT=ON>"
    "$<$<BOOL:${glaze_EETF_FORMAT}>:-DEXTERNAL_MODULE_PATH=${PROJECT_SOURCE_DIR}/cmake>"
    --test-command "${CMAKE_CTEST_COMMAND}" --verbose --output-on-failure # inner ctest command
    )

    set_tests_properties(glaze-install_test PROPERTIES FIXTURES_SETUP glaze-install-fixture)
    set_tests_properties(find_package_test PROPERTIES FIXTURES_REQUIRED glaze-install-fixture)
endif()

=== tests/json_test/CMakeLists.txt ===
project(json_test)

set(JSON_TEST_SOURCES json_test.cpp)
set(JSON_VARIANT_SUPPORT_SOURCES json_variant_support_test.cpp)

function(add_glz_json_test target)
    add_executable(${target} ${ARGN})
    target_link_libraries(${target} PRIVATE glz_test_common)

    if (MINGW)
        target_compile_options(${target} PRIVATE "-Wa,-mbig-obj")
    endif ()

    add_test(NAME ${target} COMMAND ${target})

    target_code_coverage(${target} AUTO ALL)

    set(non_null_target ${target}_non_null)
    add_executable(${non_null_target} ${ARGN})
    target_compile_definitions(${non_null_target} PRIVATE GLZ_NULL_TERMINATED=false)
    target_link_libraries(${non_null_target} PRIVATE glz_test_common)

    if (MINGW)
        target_compile_options(${non_null_target} PRIVATE "-Wa,-mbig-obj")
    endif ()

    add_test(NAME ${non_null_target} COMMAND ${non_null_target})
endfunction()

add_glz_json_test(${PROJECT_NAME} ${JSON_TEST_SOURCES})
add_glz_json_test(json_variant_support_test ${JSON_VARIANT_SUPPORT_SOURCES})

set_tests_properties(json_test json_test_non_null PROPERTIES TIMEOUT 60)

## glz::generic test

add_executable(json_t_test generic_test.cpp)

target_link_libraries(json_t_test PRIVATE glz_test_common)

add_test(NAME json_t_test COMMAND json_t_test)

## glz::generic_i64 and glz::generic_u64 tests

add_executable(generic_int_test generic_int_test.cpp)

target_link_libraries(generic_int_test PRIVATE glz_test_common)

add_test(NAME generic_int_test COMMAND generic_int_test)

## JSON Schema test

add_executable(jsonschema_test jsonschema_test.cpp)

target_link_libraries(jsonschema_test PRIVATE glz_test_common)

add_test(NAME jsonschema_test COMMAND jsonschema_test)

## Variant ambiguous test - test for ambiguous variant handling

add_executable(variant_ambiguous_test variant_ambiguous_test.cpp)

target_link_libraries(variant_ambiguous_test PRIVATE glz_test_common)

add_test(NAME variant_ambiguous_test COMMAND variant_ambiguous_test)

## Value-based skip test - test for issue #1994

add_executable(value_based_skip_test value_based_skip_test.cpp)

target_link_libraries(value_based_skip_test PRIVATE glz_test_common)

add_test(NAME value_based_skip_test COMMAND value_based_skip_test)

## Nullable lambda test - tests that lambdas returning nullable types can be skipped

add_executable(nullable_lambda_test nullable_lambda_test.cpp)

target_link_libraries(nullable_lambda_test PRIVATE glz_test_common)

add_test(NAME nullable_lambda_test COMMAND nullable_lambda_test)

## Byte array test - test for issue #1959 and PR #1966

add_executable(byte_array_test byte_array_test.cpp)

target_link_libraries(byte_array_test PRIVATE glz_test_common)

add_test(NAME byte_array_test COMMAND byte_array_test)

## Indexed rename_key test - generic solution for issue #1117

add_executable(indexed_rename_key_test indexed_rename_key_test.cpp)

target_link_libraries(indexed_rename_key_test PRIVATE glz_test_common)

add_test(NAME indexed_rename_key_test COMMAND indexed_rename_key_test)

## Skip null on read test - test for issue #1047

add_executable(skip_null_on_read_test skip_null_on_read_test.cpp)

target_link_libraries(skip_null_on_read_test PRIVATE glz_test_common)

add_test(NAME skip_null_on_read_test COMMAND skip_null_on_read_test)

## u8string test - test for std::u8string support as both buffer and value types

add_executable(u8string_test u8string_test.cpp)

target_link_libraries(u8string_test PRIVATE glz_test_common)

add_test(NAME u8string_test COMMAND u8string_test)

## JSON Patch test - RFC 6902

add_executable(json_patch_test json_patch_test.cpp)

target_link_libraries(json_patch_test PRIVATE glz_test_common)

add_test(NAME json_patch_test COMMAND json_patch_test)

## JSON Merge Patch test - RFC 7386

add_executable(json_merge_patch_test json_merge_patch_test.cpp)

target_link_libraries(json_merge_patch_test PRIVATE glz_test_common)

add_test(NAME json_merge_patch_test COMMAND json_merge_patch_test)

## Linear search test - test for linear_search compile-time option

add_executable(linear_search_test linear_search_test.cpp)

target_link_libraries(linear_search_test PRIVATE glz_test_common)

add_test(NAME linear_search_test COMMAND linear_search_test)

## Allocate raw pointers test - test for allocate_raw_pointers compile-time option (issue #2192)

add_executable(allocate_raw_pointers_test allocate_raw_pointers_test.cpp)

target_link_libraries(allocate_raw_pointers_test PRIVATE glz_test_common)

add_test(NAME allocate_raw_pointers_test COMMAND allocate_raw_pointers_test)

## snprintf fallback test - tests float_format with forced snprintf fallback (for iOS < 16.3 compatibility)

add_executable(snprintf_fallback_test snprintf_fallback_test.cpp)

target_link_libraries(snprintf_fallback_test PRIVATE glz_test_common)

add_test(NAME snprintf_fallback_test COMMAND snprintf_fallback_test)

## glz::lazy test - lazy JSON type that stores string_views

add_executable(lazy_test lazy_test.cpp)

target_link_libraries(lazy_test PRIVATE glz_test_common)

add_test(NAME lazy_test COMMAND lazy_test)

=== tests/networking_tests/CMakeLists.txt ===
# glz_asio is defined in the parent tests/CMakeLists.txt

option(glaze_BUILD_SSL_TESTS "Build SSL/TLS tests (requires OpenSSL headers matching target architecture)" ON)

# HTTP Examples
add_subdirectory(http_examples)
add_subdirectory(http_server_post_test)

# Networking Tests
add_subdirectory(asio_repe)
add_subdirectory(http_router_test)
add_subdirectory(url_test)
add_subdirectory(http_client_test)
add_subdirectory(http_client_no_ssl_executor_test)
if(glaze_BUILD_SSL_TESTS)
    add_subdirectory(http_client_ssl_test)
endif()
add_subdirectory(http_server_api_tests)
if(glaze_BUILD_SSL_TESTS)
    add_subdirectory(https_test)
endif()
add_subdirectory(jsonrpc_registry_test)
add_subdirectory(openapi_test)
add_subdirectory(repe_buffer_test)
add_subdirectory(repe_plugin_test)
add_subdirectory(repe_test)
add_subdirectory(registry_view_test)
add_subdirectory(repe_to_jsonrpc_test)
add_subdirectory(rest_test)
add_subdirectory(websocket_test)

=== tests/ordered_map_test/CMakeLists.txt ===
project(ordered_map_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/ordered_small_map_test/CMakeLists.txt ===
project(ordered_small_map_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/yaml_conformance/CMakeLists.txt ===
project(yaml_conformance)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
add_executable(${PROJECT_NAME}_struct ${PROJECT_NAME}_struct.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_common)
target_link_libraries(${PROJECT_NAME}_struct PRIVATE glz_test_common)

if (MINGW)
    target_compile_options(${PROJECT_NAME} PRIVATE "-Wa,-mbig-obj")
    target_compile_options(${PROJECT_NAME}_struct PRIVATE "-Wa,-mbig-obj")
endif ()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})
add_test(NAME ${PROJECT_NAME}_struct COMMAND ${PROJECT_NAME}_struct)

target_code_coverage(${PROJECT_NAME} AUTO ALL)
target_code_coverage(${PROJECT_NAME}_struct AUTO ALL)

# Data-driven test that iterates over the yaml-test-suite case directories.
# Off by default to avoid pulling an external repository during normal builds.
option(glaze_YAML_CONFORMANCE_DATA "Build data-driven yaml-test-suite conformance test (fetches external repo)" OFF)
if (glaze_YAML_CONFORMANCE_DATA)
    include(FetchContent)
    FetchContent_Declare(
        yaml_test_suite
        GIT_REPOSITORY https://github.com/yaml/yaml-test-suite.git
        GIT_TAG 6ad3d2c62885d82fc349026c136ef560838fdf3d # data branch, pinned 2026-02-18
    )
    FetchContent_MakeAvailable(yaml_test_suite)

    add_executable(${PROJECT_NAME}_data ${PROJECT_NAME}_data.cpp)
    target_link_libraries(${PROJECT_NAME}_data PRIVATE glz_test_common)
    target_compile_definitions(${PROJECT_NAME}_data PRIVATE
        YAML_TEST_SUITE_DIR="${yaml_test_suite_SOURCE_DIR}"
    )
    if (MINGW)
        target_compile_options(${PROJECT_NAME}_data PRIVATE "-Wa,-mbig-obj")
    endif ()
    add_test(NAME ${PROJECT_NAME}_data COMMAND ${PROJECT_NAME}_data)
    target_code_coverage(${PROJECT_NAME}_data AUTO ALL)
endif ()

=== tests/networking_tests/http_client_no_ssl_executor_test/CMakeLists.txt ===
project(http_client_no_ssl_executor_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== tests/networking_tests/http_client_ssl_test/CMakeLists.txt ===
# HTTP Client SSL Test CMakeLists.txt
cmake_minimum_required(VERSION 3.21)
project(http_client_ssl_test)

# Only build if OpenSSL is available
find_package(OpenSSL REQUIRED)

# Test if we can actually compile with OpenSSL headers
include(CheckCXXSourceCompiles)
set(CMAKE_REQUIRED_LIBRARIES OpenSSL::SSL OpenSSL::Crypto)
check_cxx_source_compiles("
    #include <openssl/ssl.h>
    #include <openssl/opensslconf.h>
    #include <openssl/evp.h>
    #include <openssl/x509.h>
    #include <openssl/pem.h>
    int main() { return 0; }
" OPENSSL_HEADERS_AVAILABLE)

if(OPENSSL_HEADERS_AVAILABLE)
    add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)
    target_link_libraries(${PROJECT_NAME}
        PRIVATE
        glz_test_exceptions
        OpenSSL::SSL
        OpenSSL::Crypto
    )
    target_compile_definitions(${PROJECT_NAME} PRIVATE GLZ_ENABLE_SSL SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")

    # Set C++ standard
    target_compile_features(${PROJECT_NAME} PRIVATE cxx_std_23)

    add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

    message(STATUS "HTTP client SSL test will be built with OpenSSL support")
else()
    message(FATAL_ERROR "OpenSSL headers missing - install libssl-dev/openssl-devel")
endif()

=== tests/networking_tests/http_client_test/CMakeLists.txt ===
project(http_client_test)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

target_link_libraries(${PROJECT_NAME} PRIVATE glz_test_exceptions)

# Conditionally enable SSL support if OpenSSL is available
find_package(OpenSSL QUIET)
if(OpenSSL_FOUND)
    include(CheckCXXSourceCompiles)
    set(CMAKE_REQUIRED_LIBRARIES OpenSSL::SSL OpenSSL::Crypto)
    check_cxx_source_compiles("
        #include <openssl/ssl.h>
        int main() { return 0; }
    " OPENSSL_HEADERS_AVAILABLE)

    if(OPENSSL_HEADERS_AVAILABLE)
        target_link_libraries(${PROJECT_NAME} PRIVATE OpenSSL::SSL OpenSSL::Crypto)
        target_compile_definitions(${PROJECT_NAME} PRIVATE GLZ_ENABLE_SSL)
        message(STATUS "HTTP client test built with SSL support")
    endif()
endif()

add_test(NAME ${PROJECT_NAME} COMMAND ${PROJECT_NAME})

=== PKGBUILD ===
# Maintainer: llm96 <llm96@fervidex.net>

_realname=glaze
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=7.1.0
pkgrel=1
pkgdesc="An Extremely fast, In-Memory JSON and Interface Library for Modern C++ (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
msys2_references=(
  'archlinux: glaze'
)
url="https://github.com/stephenberry/${_realname}"
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc")
source=("$url/archive/v$pkgver/${_realname}-$pkgver.tar.gz")
sha256sums=('39bbd40f6a81e7b56489cf96f768195563f36cf80bdfe74c3a95a228402af298')

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -Dglaze_ENABLE_FUZZING=OFF \
      -Dglaze_DEVELOPER_MODE=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
